# encoding: utf-8
# 
# Класс, печатающий состояние и результаты игры
#
# Логика взята из методов первой версии игры "виселица" (см. исходники прошлых уроков)
class ResultPrinter
  def initialize
    @status_image = []

    currentt_path = File.dirname(__FILE__)
    counter = 0
    while counter <= 7 do
      file_name = currentt_path + "/image/#{counter}.txt"
      begin
        f = File.new(file_name, "r:UTF-8")
        @status_image << f.read
        f.close
      rescue Errno::ENOENT
        @status_image << " "
      end
      counter += 1
    end
  end

  # основной метод, печатающий состояния объекта класса Game,
  # который нужно передать в качестве параметра
  def print_status(game)
    cls
    puts "\nСлово: #{get_word_for_print(game.letters, game.good_letters)}"

    # puts "Ошибки (#{game.errors}): #{game.bad_letters.to_s}" / 2 заменяется на:
    puts "Ошибки: #{game.bad_letters.join(", ").to_s}"
    # метод join возвращает элементы массива, объединенные в строку, с заданным разделителем

    print_viselitsa(game.errors)

    if game.status == -1
      puts "\nВы проиграли :(\n"
      puts "Загаданное слово было: " + game.letters.join("")
      puts
    elsif game.status == 1
      puts "Поздравляем, вы выиграли!\n\n"
    else
        if (game.errors >= 1 && game.errors <= 2)
            puts "\nУ вас осталось #{(7 - game.errors).to_s} попыток"
        elsif (game.errors >=3 && game.errors <=5)
            puts "\nУ вас осталась #{(7 - game.errors).to_s} попытки"
        elsif (game.errors == 6)
            puts "\nУ вас осталась #{(7 - game.errors).to_s} попытка"
        end
    end
  end


  # Служебный метод класса, возвращающий строку, изображающую загаданное слово
  # с открытыми угаданными буквами (см. подробности в исходниках первой версии игры)
  def get_word_for_print(letters, good_letters)
    result = ""

    for item in letters do
      if good_letters.include?(item)
        result += item + " "
      else
        result += "__ "
      end
    end

    return result
  end

  def print_viselitsa(errors)
    puts @status_image[errors]
  end

  def cls
    system "clear" or system "cls"
  end
end
