# encoding: utf-8
#
# Популярная детская игра, версия 3 - объектно-ориентированная (с использованием классов)
# https://ru.wikipedia.org/wiki/Виселица_(игра)

# Путь к файлу
current_path = "./" + File.dirname(__FILE__)
# вставляем наши классы
require current_path + "/game.rb"
require current_path + "/result_printer.rb"
require current_path + "/word_reader.rb"

# создаем объект, печатающий результаты
printer = ResultPrinter.new
# Объект читающий файлы
reader = WordReader.new

puts "Игра виселица. Версия 3. Объектно-ориентированная. (c) 2014 Mike Butlitsky\n\n"
sleep 1

slovo = reader.read_from_file(current_path + '/data/words.txt')
# создаем объект типа Game, в конструкторе нужно передать загаданное слово
game = Game.new(slovo)
# основной цикл программы, в котором развивается игра
# выходим из цикла, когда объект игры сообщит нам, c пом. метода status
while game.status == 0 do
  # выводим статус игры
  printer.print_status(game)
  # просим угадать следующую букву
  game.ask_next_letter
end

printer.print_status(game)

# Обратите внимание насколько короче, проще и элегантнее стал основной код программы.
# В этом и заключается сила объектно-ориентированного подхода.